<?php
/**
	 Raspberrysettings View File
 
	 @Copyright 2014 Stefan Rick
	 @author Stefan Rick
	 Mail: stefan@rick-software.de
	 Web: http://www.netzberater.de
	 
	 No License - see License.txt in Main Plugin Folder
 */ 
?>											

<script>
<?php if($rs->view->alsavalues){ ?>
	<?php foreach ($rs->view->alsavalues as $key => $value) { 
		$key = str_replace(' ','_', $key); ?>
		$(function() {
			<?php if(isset($value['valMap'])) { 
				echo 'var valMap = '.$value['valMap'].';';
				?>
				var valMapInvert={};
				$.each(valMap, function(i, el) {
					valMapInvert[el]=i;
				});
				<?php
			}
			?>
			$( "#<?php echo $key ?>-slider" ).slider({
				range: "min",				
				
				<?php if(isset($value['valMap'])) { ?>
					min: 0,
					value: valMapInvert[$( "#<?php echo $key ?>" ).attr('value')],				 
					max: valMap.length - 1,
					slide: function( event, ui ) {
						$( "#<?php echo $key ?>" ).val( valMap[ui.value] );
					}
				<?php }else { ?>
					min: <?php echo $value['min'] ?>,
					value: $( "#<?php echo $key ?>" ).attr('value'),
					max: <?php echo $value['max'] ?>,
					slide: function( event, ui ) {
						$( "#<?php echo $key ?>" ).val( ui.value );
					}
				<?php } ?>
			});
		});
<?php }} ?>	
</script>

<h1 class="entry-header">
	<?php echo _("Raspberry Settings"); 
		  if($rs->info->boardname) echo ' - '._t("detected").' '.$rs->info->boardname;?>
</h1>
<div class="entry-content">
	<?php if(isset($rs->view->message[0])){ ?>
		<div class="ui-widget">
			<div class="ui-state-highlight ui-corner-all" style="margin-bottom: 10px; padding: 0.4em .7em;">
				<p>
					<span class="ui-icon ui-icon-info" style="float: left; margin-right: .3em;"></span>
					<?php echo implode('<br /><span class="ui-icon ui-icon-info" style="float: left; margin-right: .3em;"></span>', $rs->view->message); ?>					
				</p>
			</div>
		</div>
	<?php } ?>	
	
	
	<form action="" method="get">
		<input type="hidden" id="action" name="action" value="" />			
		
		<p class="ui-state-default ui-corner-all" style="padding:4px;margin-bottom:1em;">
			<span class="ui-icon ui-icon-wrench" style="float:left; margin:-2px 5px 0 0;"></span>
			<b><?php echo _t("Choose Soundcard to load on boot (device tree overlay)") ?></b></p>
		<?php echo _t("Remember to change the audiodevice in your desired player (e.g. squeezelite / shairport) in tab audioplayer after enabling the card and rebooting.");?><br />
		<?php echo _t("Some audiocards like HiFi-Berry might not support simultanous usage of more than one audioplayer! Make sure to only assign one audioplayer at a time to that card.");?><br /><br />
		<?php echo _t("The following DACs/AMPs are supported. Just choose the one that should be enabled and click save.");?>
		<?php echo _t("After Reboot you may find more options (e.g. volume settings) for your selected soundcard on this page.");?><br />		
		<select name="dtoverlay">
		<?php foreach ($rs->usbSoundCards as $card => $value) { ?>
			<option value="<?php echo $card ?>" <?php if ($rs->view->dtoverlay == $card) echo 'selected'; ?>><?php echo $value['name'] ?></option>
		<?php } ?>			
		</select><br />
		<input type="button" id="save" name="<?php echo _("save") ?>" onclick="document.getElementById('action').value='save_dtoverlay';submit();" value="<?php echo _("save") ?>" />
		
		<?php if($rs->view->alsavalues){ ?>
			<br /><br />
			<div style="float:left;width:70%;">
				<?php foreach ($rs->view->alsavalues as $key => $value) { ?>
					<label for="<?php echo str_replace(' ','_', $key) ?>"><?php echo _t("Settings for "). $value['description'] ?></label>
					<input type="text" id="<?php echo str_replace(' ','_', $key) ?>" name="<?php echo str_replace(' ','_', $key) ?>" value="<?php echo $value['value'] ?>" readonly style="width:40px;border:0; color:#f6931f; font-weight:bold;">
					<div id="<?php echo str_replace(' ','_', $key) ?>-slider"></div>
					<br />				
				<?php }?>
			</div>			
			<input type="button" style="float:left;margin: 25px;" value="<?php echo _('save') ?>" name="save" onclick="document.getElementById('action').value='save_alsa';submit();" />
			<br style="width:100%;clear:both;" />
		<?php }?>
		
		<?php if(($rs->view->dtoverlay == 'rpi-cirrus-wm5102-overlay' || $rs->view->dtoverlay == 'rpi-cirrus-wm5102') && $rs->view->wolfson_active == true){ ?>
			<br /><br />
			<?php echo _t('Change Soundoutput for Wolfson Audiocard') ?>: 
			<select name="cirrus-option">
				<option value=""></option>
				<option value="Playback_to_Headset"><?php echo _t('Playback to Headset') ?></option>
				<option value="Playback_to_Lineout"><?php echo _t('Playback to Lineout') ?></option>
				<option value="SPDIF_playback"><?php echo _t('Playback to SPDIF') ?></option>
				<option value="Playback_to_Speakers"><?php echo _t('Playback to Speakers') ?></option>
			</select>
			<input type="button" style="" value="<?php echo _('save') ?>" name="save" onclick="document.getElementById('action').value='save_alsa';submit();" />
			<br style="width:100%;clear:both;" />
		<?php }?>
		
		<br /><br />
		<p class="ui-state-default ui-corner-all" style="padding:4px;margin-bottom:1em;">
			<span class="ui-icon ui-icon-wrench" style="float:left; margin:-2px 5px 0 0;"></span>
			<b><?php echo _t("Overclocking and GPU-Memory") ?></b></p>
		<?php echo _t("To get the maximum performance out of your Raspberry PI A/B/B+ you may change the frequency and the amount of memory used for GPU (graphics).");?><br />
		
		<div class="optiondetails"> 
			<table class="settings">
			  <tr>
				<td><?php echo _t("CPU Frequency") ?></td>
				<td>
					<select style="width: 90%;" name="arm_freq">
					<?php foreach ($rs->armFrequency[$rs->info->chipset] as $value) { ?>
						<option value="<?php echo $value['arm_freq'] ?>" <?php if ($rs->view->arm_freq == $value['arm_freq']) echo 'selected'; ?>><?php echo $value['name'].': '.$value['arm_freq'].'MHZ (core_freq='.$value['core_freq'].', sdram_freq='.$value['sdram_freq'].', over_voltage='.$value['over_voltage'].')' ?></option>
					<?php } ?>	
					</select>
				</td>
				<td><?php echo _t("More CPU-Power results in more heat. <a href='http://www.raspberrypi.org/documentation/configuration/config-txt.md' target='_blank'>More Information</a>") ?></td> 
			  </tr>	 
			  <tr>
				<td><?php echo _t("GPU-Memory") ?></td>
				<td><input type="text" id="gpu_mem" name="gpu_mem" value="<?php echo $rs->view->gpu_mem ?>" /></td>
				<td><?php echo _t("Default for Kodi/XBMC should be 128 MB. If you do not need any graphics, set it to 16 MB, which is the minimum. <a href='http://www.raspberrypi.org/documentation/configuration/config-txt.md' target='_blank'>More Information</a>"); ?></td> 
			  </tr>	
			  <tr>
				<td><?php echo _t("Max USB-Current") ?></td>
				<td><input type="checkbox" id="max_usb_current" name="max_usb_current" value="1" <?php if($rs->view->max_usb_current) echo 'checked'; ?> /></td>
				<td><?php echo _t("Increases the intensity of current on USB-Ports. If enabled, the USB-Ports get 1.2A instead of only 0.6A."); ?></td> 
			  </tr>	 
			  <tr>
				<td><?php echo _t("Disable Bluetooth on RPI3") ?></td>
				<td><input type="checkbox" id="disable_bluetooth" name="disable_bluetooth" value="1" <?php if($rs->view->disable_bluetooth) echo 'checked'; ?> /></td>
				<td><?php echo _t("Disable Bluetooth on Pi 3. This may be neccessary to get the HifiBerry Digi+ and Dac+ Pro working."); ?></td> 
			  </tr>
			  <tr>
				<td><?php echo _t("Disable Default WiFi Interface WLAN0 on RPI3") ?></td>
				<td><input type="checkbox" id="disable_wifi" name="disable_wifi" value="1" <?php if($rs->view->disable_wifi) echo 'checked'; ?> /></td>
				<td><?php echo _t("This moves the build-in WiFi on Pi 3 to wlan1. This is neccessary to add another WiFi stick on interface wlan0."); ?></td> 
			  </tr>	 
			  <tr>
				<td><?php echo _t("Enable LIRC for IR-Support") ?></td>
				<td><input type="checkbox" id="enable_lirc" name="enable_lirc" value="1" <?php if($rs->view->enable_lirc) echo 'checked'; ?> /><br />
				 GPIO IN (receive) <select name="input_lirc"><option value="18" <?php if($rs->view->input_lirc == 18) echo 'selected' ?> />18</option><option value="25" <?php if($rs->view->input_lirc == 25) echo 'selected' ?> />25</option></select><br />
				 GPIO OUT (send) <select name="output_lirc"><option value="17" <?php if($rs->view->output_lirc == 17) echo 'selected' ?> />17</option><option value="24" <?php if($rs->view->output_lirc == 24) echo 'selected' ?> />24</option></select></td>
				<td><?php echo _t("Enable LIRC to connect IR-Diode to send / receive IR Signals over GPIO pins."); ?></td> 
			  </tr>
			  <tr>
				<td><?php echo _t("Disable Build-In-Audio") ?></td>
				<td><input type="checkbox" id="disable_buildinaudio" name="disable_buildinaudio" value="1" <?php if($rs->view->disable_buildinaudio) echo 'checked'; ?> /></td>
				<td><?php echo _t("Disable Build-In-Audio (remove HDMI/Headphone Jack and put any other connected audiocard on position 0). This may be neccessary to get the HifiBerry AMP+ working."); ?></td> 
			  </tr>
			  <tr>
				<td><?php echo _t("Enable I2S-MMAP (Mixerdevice for Soundcards)") ?></td>
				<td><input type="checkbox" id="enable_i2s_mmap" name="enable_i2s_mmap" value="1" <?php if($rs->view->enable_i2s_mmap) echo 'checked'; ?> /></td>
				<td><?php echo _t("Enable the DMIX Alsa Mixer for HifiBerry, IQAudiO and other external soundcards. You must choose the DMIX device as output (soundcard) for all players to get multiple streams on one soundcard (e.g. with Multisqueeze Addon or Shairport/Squeezelite)."); ?></td> 
			  </tr>
			  <tr>
				<td><?php echo _t("Disable IPv6") ?></td>
				<td><input type="checkbox" id="disable_ipv6" name="disable_ipv6" value="1" <?php if($rs->view->disable_ipv6) echo 'checked'; ?> /></td>
				<td><?php echo _t("Disable IPv6. If you always want a IPv4 address in your local network. Also some links may be broken with IPv6."); ?></td> 
			  </tr>
			  <tr>
				<td><?php echo _t("Enable 64 Bit Kernel (Pi4 ONLY)") ?></td>
				<td><input type="checkbox" id="enable_64bit" name="enable_64bit" value="1" <?php if($rs->view->enable_64bit) echo 'checked'; ?> /></td>
				<td><?php echo _t("Enable 64 Bit Kernel on Raspberry Pi 4. This improves performance but might be not as stable as normal 32 Bit mode."); ?></td> 
			  </tr>	 
			</table>
			<br />
			<input type="button" id="save" name="<?php echo _("save") ?>" onclick="document.getElementById('action').value='save_performance';submit();" value="<?php echo _("save") ?>" />
		</div>
		
		
		<p class="ui-state-default ui-corner-all" style="padding:4px;margin-top:3em;">
				<span class="ui-icon ui-icon-gear" style="float:left; margin:-2px 5px 0 0;"></span>
				<?php echo _('Set Audio Output on Raspberry PI') ?>				
		</p>
		<br />
		
		<?php echo _("Use this to change the audio output of your Raspberry PI - if you have HDMI connected and you want to output sound through the headphone jack.")?>
		<br />
		<select name="AudioOutputPI">
				<option <?php if($rs->view->audioOutputPI == '0') echo 'selected'; ?> value='0'><?php echo _("Default (use HDMI if plugged)") ?></option>
				<option <?php if($rs->view->audioOutputPI == '1') echo 'selected'; ?> value='1'><?php echo _("force Headphone Jack") ?></option>
				<option <?php if($rs->view->audioOutputPI == '2') echo 'selected'; ?> value='2'><?php echo _("force HDMI") ?></option>					
		</select>
		&nbsp;&nbsp;
		<input type="button" value="<?php echo _('save') ?>" name="save" onclick="document.getElementById('action').value='setAudioOutputPI';submit();" />
		
		
		<br /><br />
		<p class="ui-state-default ui-corner-all" style="padding:4px;margin-top:3em;">
				<span class="ui-icon ui-icon-wrench" style="float:left; margin:-2px 5px 0 0;"></span>
				<?php echo _t('Change HDMI Settings for Display Resolution, Framerate and Audio') ?>				
		</p>
		
		<div class="optiondetails"> 
			<table class="settings">
			  <tr>
				<td><?php echo _t("HDMI-Resolution") ?></td>
				<td>
					<select name="hdmi_setup" style="width: 90%;">
						<option value=''><?php echo _t("not set (default)") ?></option>	
						<?php foreach ($rs->view->supported_hdmi_modes as $value) { ?>
							<option <?php if($rs->view->hdmi_setup == $value['hdmi_setup']) echo 'selected'; ?> value='<?php echo $value['hdmi_setup']; ?>'><?php echo $value['details'] ?></option>
						<?php } ?>					
					</select>
				</td>
				<td><?php echo _t("Important: you have to connect your Raspberry through HDMI to your monitor/TV before changing this parameters. Otherwise autodetection won't work.")?></td> 
			  </tr>
			  <tr>
				<td><?php echo _t("HDMI-Mode") ?></td>
				<td>
					<select name="hdmi_drive" style="width: 90%;">
						<option value=''><?php echo _t("not set (default)") ?></option>	
						<option <?php if($rs->view->hdmi_drive == "1") echo 'selected'; ?> value='1'>DVI / VGA</option>
						<option <?php if($rs->view->hdmi_drive == "2") echo 'selected'; ?> value='2'>HDMI</option>
					</select>
				</td>
				<td><?php echo _t("This may be needed, if you connect to a DVI monitor and choose a fixed HDMI-Resolution or to force audio over HDMI.")?></td> 
			  </tr>
			   <tr>
				<td><?php echo _t("HDMI Force Hotplug") ?></td>
				<td><input type="checkbox" name="hdmi_force_hotplug" value="1" <?php if($rs->view->hdmi_force_hotplug == "1") echo "checked"; ?> /></td>
				<td><?php echo _t('Activate to be able to connect HDMI after boot (otherwise HDMI output will be blank). To always have the correct HDMI output even if your TV is not active on boot, choose the HDMI-Resolution, the HDMI-Mode and activate HDMI Force Hotplug.')?>
					<?php echo _t('If no HDMI-Resolution is available, you need to activate Hotplug and reboot one time') ?>
				</td> 
			  </tr>
			  <tr>
				<td><?php echo _t("Disable Overscan") ?></td>
				<td><input type="checkbox" name="disable_overscan" value="1" <?php if($rs->view->disable_overscan == "1") echo "checked"; ?> /></td>
				<td><?php echo _t('Disable Overscan (sometimes needed to fit screen to your TV)')?></td> 
			  </tr>  
			  <tr>
				<td><?php echo _t("Disable Screen Sleep on Desktop") ?></td>
				<td><input type="checkbox" name="screen_sleep" <?php if($rs->view->screen_sleep == "X -s 0 dpms") echo "checked"; ?> value="X -s 0 dpms" /></td>
				<td><?php echo _t('Prevent a black screen after some time')?></td> 
			  </tr>
			  <tr>
				<td><?php echo _t("Disable Under-Voltage warning (square in top right corner)") ?></td>
				<td><input type="checkbox" name="avoid_warnings" <?php if($rs->view->avoid_warnings == "1") echo "checked"; ?> value="1" /></td>
				<td><?php echo _t('Prevent to show warning box.')?></td> 
			  </tr>
			  <tr>
				<td><?php echo _t("Enable High-Resolution Audio on HDMI") ?></td>
				<td><select name="enable192khzHDMI" style="width: 90%;" >
						<option value=''><?php echo _t("default") ?></option>	
						<option value='kernelm2p.img' <?php if ($rs->view->enable192khzHDMI == 'kernelm2p.img' || $rs->view->enable192khzHDMI == 'kernel7m2p.img' || $rs->view->enable192khzHDMI == 'kernel4.1.12+M2P.img') echo 'selected'; ?>><?php echo _t("Max2Play Kernel with 192Khz enabled") ?></option>	
					</select>
				</td>
				<td><?php echo _t('Activate 192Khz sample rate and 32Bit encoding for soundoutput through HDMI. Important: Set Alsa-Parameter for Squeezelite on page Audioplayer to "::16:0" (fix bitrate to 16 and disable MMAP) if you get no sound at all or crackling sound!')?></td> 
			  </tr>	 
			</table>
			<br />
			<input type="button" value="<?php echo _('save') ?>" name="save" onclick="document.getElementById('action').value='saveHDMISettings';submit();" />
		</div>
				
		<br /><br />
		<p class="ui-state-default ui-corner-all" style="padding:4px;margin-bottom:1em;">
			<span class="ui-icon ui-icon-video" style="float:left; margin:-2px 5px 0 0;"></span>
			<b><?php echo _t("License Keys for Hardware Video decoding") ?></b></p>
		<?php echo _t("Enable your Raspberry Pi to decode MPEG-2 video and VC-1 video in hardware");?><br />
		
		<div class="optiondetails"> 
			<table class="settings">
			  <tr>
				<td><?php echo _t("Your Serialnumber to Order Licence Keys") ?></td>
				<td>
					<?php echo $rs->view->serialnumber ?>
				</td>
				<td><?php echo _t("You need this number to order your License Keys to support either MPEG-2 (<a href='http://www.raspberrypi.com/mpeg-2-license-key/' target='blank'>http://www.raspberrypi.com/mpeg-2-license-key/</a>) OR VC-1 (<a href='http://www.raspberrypi.com/vc-1-license-key/' target='blank'>http://www.raspberrypi.com/vc-1-license-key/</a>)") ?></td> 
			  </tr>	 
			  <tr>
				<td><?php echo _t("MPEG-2 Video License Key - <b>Status: "). $rs->view->mpeg2_status ?></b></td>
				<td><input type="text" id="mpeg2_key" name="mpeg2_key" value="<?php echo $rs->view->mpeg2_key ?>" style="width: 90%;" /></td>
				<td><?php echo _t("Add your MPEG-2 License Key"); ?></td> 
			  </tr>	 
			  <tr>
				<td><?php echo _t("VC-1 Video License Key - <b>Status: "). $rs->view->vc1_status ?></b></td>
				<td><input type="text" id="vc1_key" name="vc1_key" value="<?php echo $rs->view->vc1_key ?>" style="width: 90%;" /></td>
				<td><?php echo _t("Add your VC-1 License Key"); ?></td> 
			  </tr>	 
			</table>
			<br />
			<input type="button" id="save" name="<?php echo _("save") ?>" onclick="document.getElementById('action').value='save_hwvideo';submit();" value="<?php echo _("save") ?>" />
		</div>
		
		<br /><br />
		<p class="ui-state-default ui-corner-all" style="padding:4px;margin-bottom:1em;">
			<span class="ui-icon ui-icon-video" style="float:left; margin:-2px 5px 0 0;"></span>
			<b><?php echo _t("Plugin and Package Installer") ?></b></p>
		<select name="piplugin" style="width: 90%;">
			<option value="pijuice-base"><?php echo _t('PiJuice light version Installer (headless version without GUI) for additional configuration of PiJuice') ?></option>			
			<option value="pijuice-gui"><?php echo _t('PiJuice GUI Installer - After a restart a new icon "PiJuice Settings" will appear under Menu>Preference on desktop') ?></option>
		</select>
		<input type="button" value="<?php echo _('Install') ?>" name="save" onclick="document.getElementById('action').value='plugininstall';submit();" />
		
		<br /><br />
		<p class="ui-state-default ui-corner-all" style="padding:4px;margin-bottom:1em;">
			<span class="ui-icon ui-icon-video" style="float:left; margin:-2px 5px 0 0;"></span>
			<b><?php echo _t("Kernel and Package Updates and Upgrades") ?></b></p>
		<?php echo _t("Upgrade to latest Kernel (breaks Wolfson Audio cards!)");?>: 
		<input type="button" value="<?php echo _('Upgrade Kernel') ?>" name="save" onclick="document.getElementById('action').value='kernelupdate';submit();" />
		<br />
		<?php echo _t("Update all Packages (apt-get update; apt-get upgrade)");?>: 
		<input type="button" value="<?php echo _('Update Packages') ?>" name="save" onclick="document.getElementById('action').value='packageupdate';submit();" />		
		<br />
		<?php echo _t("Install Iceweasel (Firefox Browser) on Desktop");?>: 
		<input type="button" value="<?php echo _('Install Browser') ?>" name="save" onclick="document.getElementById('action').value='installbrowser';submit();" />
		<br />
		<br />
	</form>
	
	<br /><br />
	<a href="#javascript" onclick="document.getElementById('debug').style.display='';return false;"><?php echo _("DEBUG Informations") ?></a><br />
	<textarea id="debug" rows="30" cols="70" style="display:none;"><?php foreach ($rs->view->debug as $key => $debug) {
			echo "#### ". $key. " ####\n"; 
			 echo $debug." \n\n"; 
		 }?>
	</textarea>
</div>	